#(ie. use with rpm --rebuild):
#
#	--with debug	Compile with debugging code
#
#  enable build with debugging code: will _not_ strip away any debugging code,
#  will _add_ -g3 to CFLAGS, will _add_ --enable-maintainer-mode to
#  configure.

%define build_debug 0
%define build_test 0

# commandline overrides:
# rpm -ba|--rebuild --with 'xxx'
%{?_with_debug: %{expand: %%global build_debug 1}}
%{?_without_debug: %{expand: %%global build_debug 0}}
%{?_with_test: %{expand: %%global build_test 1}}
%{?_without_test: %{expand: %%global build_test 0}}

%if %{build_debug}
# disable build root strip policy
%define __spec_install_post %{_libdir}/rpm/brp-compress || :

# This gives extra debuggin and huge binaries
%{expand:%%define optflags %{optflags} %([ ! $DEBUG ] && echo '-g3')}
%endif

%if %{build_debug}
%define build_test 1
%define build_debug 1
%endif

%define apache_version 2.4.58
%define mod_name mod_perl

Name:       apache-%{mod_name}
Version:    2.0.13
Release:    %mkrel 2
Summary:    An embedded Perl interpreter for the apache Web server
Group:      System/Servers
License:    Apache License
Url:        https://perl.apache.org/
Source0:    https://downloads.apache.org/perl/%{mod_name}-%{version}.tar.gz
Source1:    https://downloads.apache.org/perl/%{mod_name}-%{version}.tar.gz.asc
Source2:    perl.conf
Source3:    perl.module.conf
Patch0:     mod_perl-2.0.4-inline.patch
BuildRequires: perl-devel >= 5.8.2
BuildRequires: perl(Tie::IxHash)
BuildRequires: perl(Data::Flow)
BuildRequires: apache >= %{apache_version}
%if %{build_test}
BuildRequires: perl-CGI >= 1:3.08
BuildRequires: perl-HTML-Parser
BuildRequires: perl-libwww-perl
BuildRequires: perl-URI
BuildRequires: perl-BSD-Resource
BuildRequires: apache-mod_cache >= %{apache_version}
BuildRequires: apache-mod_dav >= %{apache_version}
BuildRequires: apache-mod_deflate >= %{apache_version}
BuildRequires: apache-mod_disk_cache >= %{apache_version}
BuildRequires: apache-mod_file_cache >= %{apache_version}
BuildRequires: apache-mod_ldap >= %{apache_version}
BuildRequires: apache-mod_proxy >= %{apache_version}
BuildRequires: apache-mod_ssl >= %{apache_version}
BuildRequires: apache-mod_suexec >= %{apache_version}
BuildRequires: apache-mod_userdir >= %{apache_version}
%endif
BuildRequires: apache-devel >= %{apache_version}
Requires:   apache >= %{apache_version}
Provides:   perl(mod_perl)
Provides:   perl(mod_perl2)
# for Apache::SizeLimit to work, mga#2070
Requires:   perl(Linux::Pid)
Epoch:      1

%description
%{name} incorporates a Perl interpreter into the apache web server,
so that the Apache web server can directly execute Perl code.
Mod_perl links the Perl runtime library into the apache web server and
provides an object-oriented Perl interface for apache's C language
API.  The end result is a quicker CGI script turnaround process, since
no external Perl interpreter has to be started.

Install %{name} if you're installing the apache web server and you'd
like for it to directly incorporate a Perl interpreter.

You can build %{name} with some conditional build switches;

(ie. use with rpm --rebuild):
    --with[out] debug	Compile with debugging code (forces --with test)
    --with[out]	test	Initiate a Apache-Test run

%package	devel
Summary:    Files needed for building XS modules that use mod_perl
Group:      Development/C
Requires:   %{name} = 1:%{version}
Requires:   apache-devel >= %{apache_version}
Epoch:      1

%description	devel
The mod_perl-devel package contains the files needed for building XS
modules that use mod_perl.

%prep

%setup -q -n %{mod_name}-%{version}
%autopatch -p1

%build

for i in Changes SVN-MOVE; do
    iconv --from=ISO-8859-1 --to=UTF-8 $i > $i.utf8
    mv $i.utf8 $i
done

cd docs
for i in devel/debug/c.pod devel/core/explained.pod user/Changes.pod; do
    iconv --from=ISO-8859-1 --to=UTF-8 $i > $i.utf8
    mv $i.utf8 $i
done
cd ..

export CFLAGS="$RPM_OPT_FLAGS -fpic"

%{__perl} Makefile.PL \
    PREFIX=%{_prefix} \
    MP_APXS=%{_httpd_apxs} \
    MP_APR_CONFIG=%{_bindir}/apr-1-config \
    INSTALLDIRS=vendor \
    </dev/null

%make_build -C src/modules/perl OPTIMIZE="$RPM_OPT_FLAGS -fpic"
%make_build

%install
%if %{build_debug}
export DONT_STRIP=1
%endif

%if %{build_test}
# Run the test suite.
#  Need to make t/htdocs/perlio because it isn't expecting to be run as
#  root and will fail tests that try and write files because the server
#  will have changed it's uid.
mkdir -p t/htdocs/perlio
chmod 777 t/htdocs/perlio

#
# fix for bad_scripts.t in 1.99_12
# [Tue Mar 02 17:28:26 2004] [error] file permissions deny server execution/usr/src/packages/BUILD/modperl-2.0/ModPerl-Registry/t/cgi-bin/r_inherited.pl
if test -e ModPerl-Registry/t/cgi-bin/r_inherited.pl; then chmod +x ModPerl-Registry/t/cgi-bin/r_inherited.pl; fi
#
# 1.99_12_20040302 fix for t/hooks/cleanup.t and t/hooks/cleanup2.t
# [Tue Mar 02 18:38:41 2004] [error] [client 127.0.0.1] can't open /usr/src/packages/BUILD/modperl-2.0/t/htdocs/hooks/cleanup2: Permission denied at /usr/src/packages/BUILD/modperl-2.0/Apache-Test/lib/Apache/TestUtil.pm line 82.
mkdir -p t/htdocs/hooks
chmod 2770 t/htdocs/hooks
#
# run test suite:
#
#make TEST_VERBOSE=1 APACHE_TEST_PORT=select APACHE_TEST_STARTUP_TIMEOUT=360 test  || {
#       ps aufx | grep "/usr/sbin/httpd-prefork -d /usr/src/packages/BUILD/modperl-2.0" \
#               | grep -v grep | awk '{print $2}' | xargs -r kill
#       exit 1
#}
perl t/TEST -start-httpd -port select -startup_timeout 360 -verbose -httpd_conf /etc/httpd/conf/httpd.conf
perl t/TEST -run-tests || {
perl t/TEST -stop-httpd
    exit 1
}
perl t/TEST -stop-httpd
# in case of failures, see http://perl.apache.org/docs/2.0/user/help/help.html#_C_make_test___Failures
# then, debug like this:
# t/TEST -start-httpd
# tail -F t/logs/*&
# t/TEST -run-tests -verbose $failed_test
# t/TEST -stop-httpd

#make \
#    APACHE_TEST_PORT=select \
#    APACHE_TEST_STARTUP_TIMEOUT=30 \
#    APACHE_TEST_COLOR=1 \
#    TEST_VERBOSE=1 \
#    APACHE_TEST_HTTPD=%{_sbindir}/httpd \
#    APACHE_TEST_APXS=%{_bindir}/apxs \
#    test

%endif

install -d %{buildroot}%{_httpd_moddir}
%make_install \
    MODPERL_AP_LIBEXECDIR=%{_httpd_moddir} \
    MODPERL_AP_INCLUDEDIR=%{_includedir}/httpd \
    INSTALLDIRS=vendor

# install config file
install -d -m 755 %{buildroot}%{_httpd_extconfdir}
install -d -m 755 %{buildroot}%{_httpd_modconfdir}
install -p -m 644 %{SOURCE2} %{buildroot}%{_httpd_extconfdir}
install -p -m 644 %{SOURCE3} %{buildroot}%{_httpd_modconfdir}/02-perl.conf

# install missing required files
install -d %{buildroot}%{perl_vendorarch}/Apache2/Apache
install -m0644 xs/tables/current/Apache2/ConstantsTable.pm \
    %{buildroot}%{perl_vendorarch}/Apache2/Apache/
install -m0644 xs/tables/current/Apache2/FunctionTable.pm \
    %{buildroot}%{perl_vendorarch}/Apache2/Apache/
install -m0644 xs/tables/current/Apache2/StructureTable.pm \
    %{buildroot}%{perl_vendorarch}/Apache2/Apache/

# cleanup
find %{buildroot} -name 'perllocal.pod' -delete

# don't pack the Apache-Test stuff
rm -rf %{buildroot}%{perl_vendorarch}/Apache/Test*
rm -rf %{buildroot}%{perl_vendorarch}/MyTest
rm -f %{buildroot}%{perl_vendorarch}/Bundle/ApacheTest.pm
rm -f %{buildroot}%{_mandir}/man3/Apache::Test*
rm -f %{buildroot}%{_mandir}/man3/Bundle::ApacheTest.3pm

%files
%doc BRANCHING Changes INSTALL LICENSE META.yml NOTICE README RELEASE STATUS
%config(noreplace) %{_httpd_extconfdir}/perl.conf
%config(noreplace) %{_httpd_modconfdir}/02-perl.conf
%{_bindir}/*
%{_httpd_moddir}/mod_perl.so
%{perl_vendorarch}/Apache
%{perl_vendorarch}/Apache2
%{perl_vendorarch}/Bundle
%{perl_vendorarch}/ModPerl
%{perl_vendorarch}/APR
%{perl_vendorarch}/APR.pm
%{perl_vendorarch}/mod_perl2.pm
%{perl_vendorarch}/auto/Apache2
%{perl_vendorarch}/auto/ModPerl
%{perl_vendorarch}/auto/APR
%{_mandir}/*/*

%files devel
%{_includedir}/httpd/*


%changelog
* Fri Dec 01 2023 tv <tv> 1:2.0.13-2.mga10
+ Revision: 2012072
- Rebuild for perl-5.38

* Sat Oct 21 2023 kekepower <kekepower> 1:2.0.13-1.mga10
+ Revision: 1999947
- Update to version 2.0.13

* Mon Jun 06 2022 umeabot <umeabot> 1:2.0.12-3.mga9
+ Revision: 1861481
- Rebuild for Perl 5.36

* Thu Mar 17 2022 umeabot <umeabot> 1:2.0.12-2.mga9
+ Revision: 1796888
- Mageia 9 Mass Rebuild

* Sun Jan 30 2022 luigiwalser <luigiwalser> 1:2.0.12-1.mga9
+ Revision: 1770634
- 2.0.12
- remove upstream patch 4

* Tue May 25 2021 kekepower <kekepower> 1:2.0.11-1.mga9
+ Revision: 1728160
- Remove Patch5: mod_perl-2.0.10-restrict_perl_section_to_server_scope.patch
- Update to version 2.0.11

* Tue May 25 2021 tv <tv> 1:2.0.10-11.mga9
+ Revision: 1728116
- Fix building with perl 5.34 (Perl GH#18617)
+ tmb <tmb>
- rebuild for perl 5.34
+ umeabot <umeabot>
- Rebuild for perl 5.34

* Wed Jun 17 2020 umeabot <umeabot> 1:2.0.10-9.mga8
+ Revision: 1594202
- Rebuild for perl 5.32

* Sat Feb 15 2020 umeabot <umeabot> 1:2.0.10-8.mga8
+ Revision: 1529260
- Mageia 8 Mass Rebuild
+ wally <wally>
- replace deprecated %%makeinstall_std

* Tue Aug 27 2019 tv <tv> 1:2.0.10-7.mga8
+ Revision: 1433246
- rebuild with perl-5.30

* Wed Oct 24 2018 bcornec <bcornec> 1:2.0.10-6.mga7
+ Revision: 1325099
- apache version is now 2.4.37

* Mon Oct 22 2018 bcornec <bcornec> 1:2.0.10-5.mga7
+ Revision: 1323958
- Fix mga#23541 by adding a Fedora patch restricting perl section to server scope

* Thu Sep 20 2018 umeabot <umeabot> 1:2.0.10-4.mga7
+ Revision: 1289206
- Mageia 7 Mass Rebuild

* Mon Aug 06 2018 shlomif <shlomif> 1:2.0.10-3.mga7
+ Revision: 1248187
- Rebuild for new perl 5.28.0

* Thu Aug 31 2017 pterjan <pterjan> 1:2.0.10-2.mga7
+ Revision: 1148622
- Rebuild for perl ABI changes

* Sun Aug 20 2017 shlomif <shlomif> 1:2.0.10-1.mga7
+ Revision: 1142429
- New version 2.0.10 (MGA#16505) - thanks to Frederic Buclin.

* Sat Jul 22 2017 neoclust <neoclust> 1:2.0.9-3.mga7
+ Revision: 1126616
- Rebuild against new Perl 5.26

* Sat Jun 18 2016 pterjan <pterjan> 1:2.0.9-2.mga6
+ Revision: 1022096
- Rebuild for perl 5.22.2

* Fri Dec 18 2015 oden <oden> 1:2.0.9-1.mga6
+ Revision: 911566
- 2.0.9
- drop redundant patches

* Sat Jun 27 2015 tv <tv> 1:2.0.7-21.20130221svn1448245.mga6
+ Revision: 846043
- rebuild for soname-ifed perl

* Fri Jun 26 2015 tv <tv> 1:2.0.7-20.20130221svn1448245.mga6
+ Revision: 844728
- rebuild for soname-ifed perl

* Fri Jun 26 2015 tv <tv> 1:2.0.7-19.20130221svn1448245.mga6
+ Revision: 844621
- rebuild with soname-ified perl

* Tue Jun 23 2015 sander85 <sander85> 1:2.0.7-18.20130221svn1448245.mga6
+ Revision: 840425
- Rebuild for perl 5.22

* Wed Oct 15 2014 umeabot <umeabot> 1:2.0.7-17.20130221svn1448245.mga5
+ Revision: 748456
- Second Mageia 5 Mass Rebuild

* Wed Oct 08 2014 blino <blino> 1:2.0.7-17.20130221svn1448244.mga5
+ Revision: 737573
- rebuild for new perl

* Tue Sep 16 2014 umeabot <umeabot> 1:2.0.7-16.20130221svn1448244.mga5
+ Revision: 677844
- Mageia 5 Mass Rebuild

* Tue Jun 03 2014 pterjan <pterjan> 1:2.0.7-16.20130221svn1448243.mga5
+ Revision: 630764
- Rebuild for perl 5.20

* Tue Feb 11 2014 blino <blino> 1:2.0.7-16.20130221svn1448242.mga5
+ Revision: 589176
- rebuild for new perl

* Sat Oct 19 2013 umeabot <umeabot> 1:2.0.7-15.20130221svn1448243.mga4
+ Revision: 536669
- Mageia 4 Mass Rebuild

* Tue Sep 24 2013 blino <blino> 1:2.0.7-15.20130221svn1448242.mga4
+ Revision: 485251
- rebuild for perl 5.18.1 (to update rpath)

* Thu May 30 2013 blino <blino> 1:2.0.7-14.20130221svn1448242.mga4
+ Revision: 433425
- fix build with perl >= 5.17.6 (rt.cpan.org #83921 / svn.apache.org r1457618)
- revert to 2.0.7 snapshot
+ jquelin <jquelin>
- update to 2.0.8
- perl 5.18.0 rebuild
+ fwang <fwang>
- rebuild for new perl

* Sun Mar 17 2013 guillomovitch <guillomovitch> 1:2.0.7-12.20130221svn1448242.mga3
+ Revision: 403591
- switch to upstream svn2.4 branch, for better apache 2.4 compatibility
+ jquelin <jquelin>
- perl 5.14.4 rebuild

* Mon Feb 11 2013 guillomovitch <guillomovitch> 1:2.0.7-11.mga3
+ Revision: 397915
- use fedora patch for apache 2.4 compatibility, as ours breaks mod_perl API
  badly (#7360)
- sync spec file with fedora

* Fri Jan 11 2013 umeabot <umeabot> 1:2.0.7-10.mga3
+ Revision: 345862
- Mass Rebuild - https://wiki.mageia.org/en/Feature:Mageia3MassRebuild

* Mon Nov 05 2012 blino <blino> 1:2.0.7-9.mga3
+ Revision: 314507
- rebuild for perl 5.16.2

* Thu Aug 23 2012 jquelin <jquelin> 1:2.0.7-8.mga3
+ Revision: 283289
- perl 5.16.1 rebuild

* Sat Aug 11 2012 guillomovitch <guillomovitch> 1:2.0.7-7.mga3
+ Revision: 280760
- use apache rpm macros

* Mon Jul 23 2012 blino <blino> 1:2.0.7-6.mga3
+ Revision: 273648
- fix module conf syntax for apache 2.4 (does not allow mixing options with +/- with those without)

* Sun Jul 22 2012 blino <blino> 1:2.0.7-5.mga3
+ Revision: 273640
- install module in standard _libdir/httpd/modules location

* Sun Jul 22 2012 blino <blino> 1:2.0.7-4.mga3
+ Revision: 273609
- remove one more occurence of obsolete apache-mpm require

* Sun Jul 22 2012 blino <blino> 1:2.0.7-3.mga3
+ Revision: 273500
- fix apache configuration location (like cjw did for php)
- (build-)depends on apache >= 2.4.2

* Sun Jul 22 2012 blino <blino> 1:2.0.7-2.mga3
+ Revision: 273493
- fix apxs path
- drop obsolete apache-mpm requires
- remove scriptlets requires, now handled in filetriggers
+ luigiwalser <luigiwalser>
- Apache 2.4.x compatibility (from mdv)

* Sun Jul 15 2012 luigiwalser <luigiwalser> 1:2.0.7-1.mga3
+ Revision: 270809
- 2.0.7 (partial sync with mdv)

* Fri Jun 01 2012 blino <blino> 1:2.0.6-1.mga3
+ Revision: 252566
- 2.0.6
  (this fixes building with perl 5.16, Apache2::BuildConfig.pm was not
  parsed properly and the mv variable ended up unset)
- drop upstream/merged patches (format-string, sv_dup, sv_refcnt)
- fix build with perl 5.16 (from upstream bugzilla)
+ jquelin <jquelin>
- rebuild for perl 5.16
- rebuild for perl 5.16
- rebuild for perl 5.16
- rebuild for perl 5.16
- rebuild for perl 5.16

* Mon Mar 19 2012 luigiwalser <luigiwalser> 1:2.0.5-15.mga2
+ Revision: 223837
- httpd restart is handled by filetriggers now

* Sun Mar 04 2012 luigiwalser <luigiwalser> 1:2.0.5-14.mga2
+ Revision: 218266
- filter out -fPIE (from mdv)
- add upstream patches to fix issues with perl 5.14 (seen by pterjan)

* Fri Dec 30 2011 blino <blino> 1:2.0.5-13.mga2
+ Revision: 188962
- remove HAVE_PERL define check in config file, this check is useless
  with the current package split (and this can prevent httpd from
  starting with systemd since HAVE_ defines are not propagated anymore)

* Tue Oct 25 2011 shlomif <shlomif> 1:2.0.5-12.mga2
+ Revision: 158029
- Fix for apache crash on startup with mod_perl on i586 - https://bugs.mageia.org/show_bug.cgi?id=2439

* Sat Oct 15 2011 dmorgan <dmorgan> 1:2.0.5-11.mga2
+ Revision: 155445
- Remove unused rpm macros

* Fri Oct 14 2011 jquelin <jquelin> 1:2.0.5-10.mga2
+ Revision: 155106
- perl 5.14.2 rebuild

* Sun Sep 18 2011 dmorgan <dmorgan> 1:2.0.5-9.mga2
+ Revision: 144802
- Get rid of apache-conf

* Sun Sep 18 2011 dmorgan <dmorgan> 1:2.0.5-8.mga2
+ Revision: 144709
- Fix BR

* Sun Sep 18 2011 dmorgan <dmorgan> 1:2.0.5-7.mga2
+ Revision: 144663
- Bump release
- Change apache-base require

* Fri Sep 16 2011 dmorgan <dmorgan> 1:2.0.5-6.mga2
+ Revision: 144129
- Fix apache requires

* Thu Sep 15 2011 dmorgan <dmorgan> 1:2.0.5-5.mga2
+ Revision: 144109
- Fix apache requires

* Mon Jul 11 2011 ahmad <ahmad> 1:2.0.5-4.mga2
+ Revision: 122176
- Require perl(Linux::Pid) for Apache::SizeLimit to work (mga#2070)

* Sun Jun 19 2011 jquelin <jquelin> 1:2.0.5-3.mga2
+ Revision: 109910
- perl 5.14.1 rebuild

* Sat Jun 11 2011 sander85 <sander85> 1:2.0.5-2.mga2
+ Revision: 103926
- perl 5.14

* Thu Mar 10 2011 jquelin <jquelin> 1:2.0.5-1.mga1
+ Revision: 67721
- format string patch is back
- update to 2.0.5

* Thu Feb 17 2011 jquelin <jquelin> 1:2.0.4-25.mga1
+ Revision: 52903
- rebuild

* Wed Feb 16 2011 jquelin <jquelin> 1:2.0.4-24.mga1
+ Revision: 52700
- perl 5.12.3 rebuild

* Thu Jan 27 2011 jquelin <jquelin> 1:2.0.4-23.mga1
+ Revision: 41862
- adding missing provides:

* Mon Jan 24 2011 jquelin <jquelin> 1:2.0.4-22.mga1
+ Revision: 37508
- adding a provides:

* Mon Jan 24 2011 jquelin <jquelin> 1:2.0.4-21.mga1
+ Revision: 36858
- rebuild

* Sun Jan 23 2011 jquelin <jquelin> 1:2.0.4-20.mga1
+ Revision: 34876
- rebuild
- mageia rebuild

* Fri Jan 21 2011 jquelin <jquelin> 1:2.0.4-19.mga1
+ Revision: 28413
- imported package apache-mod_perl

